// File:        UI3tButton.cpp
// Description: Button with 3 texutres (for <enabled>, <disabled> and <touched> states)
// Created:     07.12.2004
// Author:      Serhiy 0. Vynnychenk0
// Mail:        narrator@gsc-game.kiev.ua
//
// copyright 2004 GSC Game World
//

#pragma once
#include "UIButton.h"
#include "UI_IB_Static.h"

class CUI3tButton : public CUIButton {
	friend class CUIXmlInit;
	using CUIButton::SetTextColor;
public:
	CUI3tButton();
	virtual ~CUI3tButton();
	// appearance
	using CUIButton::Init;

	virtual void Init(float x, float y, float width, float height);
	virtual void InitTexture(LPCSTR tex_name);
	virtual void InitTexture(LPCSTR tex_enabled, LPCSTR tex_disabled, LPCSTR tex_touched, LPCSTR tex_highlighted);	
			void InitTextureEnabled(LPCSTR texture);
			void InitTextureDisabled(LPCSTR texture);
			void InitTextureHighlighted(LPCSTR texture);
			void InitTextureTouched(LPCSTR texture);			
			void SetTextColor(u32 color);
			void SetTextColorH(u32 color);
			void SetTextColorD(u32 color);
			void SetTextColorT(u32 color);
	virtual void SetTextureOffset(float x, float y);	
	virtual void SetWidth(float width);
	virtual void SetHeight(float height);
			void InitSoundH(LPCSTR sound_file);
			void InitSoundT(LPCSTR sound_file);

	virtual void OnClick();
	virtual void OnFocusReceive();

	// check button
	bool GetCheck() {return m_eButtonState == BUTTON_PUSHED;}
	void SetCheck(bool ch) {m_eButtonState = ch ? BUTTON_PUSHED : BUTTON_NORMAL;}
	
	// behavior
	virtual void DrawTexture();
	virtual void Update();
	
	//virtual void Enable(bool bEnable);	
	virtual void SendMessage(CUIWindow* pWnd, s16 msg, void* pData = 0);
	virtual bool OnMouse(float x, float y, EUIMessages mouse_action);
	virtual void OnMouseDown(bool left_button = true);
			void SetCheckMode(bool mode) {m_bCheckMode = mode;}


	CUIStatic		m_hint;
	CUI_IB_Static	m_background;

			void SetFrameMode(bool mode);
	CUI_IB_FrameLineWnd m_background_frame;
	bool			m_b_frameMode;
protected:
	bool			m_bCheckMode;
private:	
			void PlaySoundH();
			void PlaySoundT();

	ref_sound		m_sound_h;
	ref_sound		m_sound_t;	
};